#pragma once

#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>

#include <armarx/control/skills/skills/aron/RelaxHandParams.aron.generated.h>

#include "../skills.h"

namespace armarx::control::skills::skills
{

    class RelaxHand : public ::armarx::skills::SimpleSpecializedSkill<RelaxHandParams>
    {

    public:
        static ::armarx::skills::SkillDescription
        GetSkillDescription()
        {
            return ::armarx::skills::SkillDescription{.skillId = {.skillName = "RelaxHand"},
                                                      .description = "Relaxes hand joints",
                                                      .timeout = ::armarx::Duration::Seconds(1),
                                                      .parametersType = ParamType::ToAronType()};
        }

        RelaxHand(const HandUnitRemote&);

    private:
        ::armarx::skills::Skill::MainResult main(const SpecializedMainInput& in) override;

    private:
        HandUnitRemote remote;
    };

} // namespace armarx::control::skills::skills
